/*
 *	Private Pilot Test Practice Program
 *
 *	brought to you by Corwin Nichols (Piper Colt N4973Z)
 *	please read the accompanying read.me file
 */

/*	Revision history
 *	Release	By	On			Remarks
 *	1.0		CN	07/20/93	Initial cut
 *  2.0		CN	03/04/94	Increased max question length, added 'X' as match
 *							  anything answer.  Rewrote help screens. Unix port.
 *  2.0a	CN	03/10/94	Removed need for 'u.h' include file for unix, fixed
 *							  'peek' command under unix
 */

/*
 *	to make on Unix: cc faa.c -o faa -l curses
 */

/*	set TAB stops to 4 for proper alignment */

#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<stdarg.h>

#ifdef	__MSDOS__
#include	<io.h>
#include	<dos.h>
#endif

#include	<sys/stat.h>
#include	<fcntl.h>
#include	<ctype.h>
#include	<malloc.h>
#include	<time.h>

/* #include	"curses.h" */
#include        <ncurses/curses.h>

#ifndef		TRUE
#define		TRUE	1
#define		FALSE	0
#endif

#ifndef	__MSDOS__
#define		FAR
#define		HUGE
#define		farmalloc	malloc
#define		O_BINARY	0
/* #define		T_DIRECT	0        already defined in curses.h */
#define		pc_uptype(scr)
#define		V_LINE	ACS_VLINE
#define		H_LINE	ACS_HLINE
#define		TTEE		ACS_TTEE
#define		RTEE		ACS_RTEE
#define		LL_CORNER	ACS_LLCORNER
#else
#define		FAR		far
#define		HUGE	huge
#define		V_LINE	D_VERT
#define		H_LINE	D_HOR
#define		TTEE	203
#define		RTEE	185
#define		LL_CORNER	200
#endif

#define		ESC		27
#define		TAB		9
#define		CR		13
#define		BACK_TAB 15 + 128
#define		UP_ARROW 72 + 128
#define		DOWN_ARROW 80 + 128

#define		MAX_LINE_SIZE	2000
#define		QUESTION_FILE	"question.db"
#define		MAX_QUESTIONS	900
#define		MAX_QUESTIONS_IN_ASKING_SET	200
#define		FIELD_COUNT		9

#define		CONTINUOUS		1
#define		SHOW_ANSWERS	2
#define		SCREEN_SIZE		80
#define		SCORE_BOX_LEFT	(SCREEN_SIZE - 18)
#define		SCORE_BOX_BOTTOM 5

typedef	struct	{
	unsigned questionNum;
	char answer;
	char FAR *question;
	int	 toAnswerA;
	int	 toAnswerB;
	int	 toAnswerC;
	int	 toQuestionHelp;
	int	 toFirstWrongHelp;
	int	 toSecondWrongHelp;
	int  toEnd;
	} questionList;

typedef	struct	{
	char	key;
	char	x, y;
	char	*msg;
	void	*value;
	}	displayList;

typedef	struct	{
	unsigned	lowValue, highValue;
	}	setList;

typedef struct	{
	questionList *question;
	char enteredAnswer;
	char status;
	}	questControl;

/*	defines for the question 'status' field above */

#define	ANSWERED	1		/* question has been answered */
#define	LOCKED		2		/* if the correct answer has been shown, don't allow changes */
#define	IN_ERROR	4		/* answer is incorrect */

/*	Globals		*/

char	Question[600], AnswerA[200], AnswerB[200], AnswerC[200];
char	QuestionHelp[200], Wrong1Help[200], Wrong2Help[200];
char	CorrectAns;
WINDOW *Display, *ScoreBox;

questionList	*Questions;
int				TotalQuestionCount = 0;
questionList	*WorkingList[2000];
int				WorkingListCount;
int				CurrentQuestion;
int				QuestionCount = 60;
int				ToGo, Done, Missed, PassedPct;
int				ImmediateFeedback = FALSE;
char			FeedbackStr[] = "OFF";
int				WorkingSet = 0;
char			WorkingSetStr[20] = "PP-ASEL";
int				SoundEffects = TRUE;
char			SoundEffectStr[] = "ON ";
char			AnsY[4];
questControl	QuestionSet[MAX_QUESTIONS_IN_ASKING_SET];

/*	Global display lists, menus, etc.	*/

displayList	bye_list[] = {
	' ', 10, 12, "Out of the clear blue of the Western Sky, it's...", NULL,
	' ', 10, 14, "Nah, just another flying nerd.", NULL,
	' ', 10, 16, "Good luck and happy flying!", NULL,
	' ', 10, 17, "  ", NULL,
	0, 0, 0, NULL, NULL };

displayList	score_list[] = {
	' ', SCORE_BOX_LEFT + 2, 1, "# missed = %d", &Missed,
	' ', SCORE_BOX_LEFT + 2, 2, "#   done = %d", &Done,
	' ', SCORE_BOX_LEFT + 2, 3, "#  to go = %d", &ToGo,
	0, 0, 0, NULL, NULL };

displayList	final_score_list[] = {
	' ', 10,  2, "Final test results", NULL,
	' ', 10,  6, "# missed   = %d", &Missed,
	' ', 10,  8, "#   done   = %d", &Done,
	' ', 10, 10, "Pct passed = %d", &PassedPct,
	' ', 10, 16, "A passing grade is 70%%", NULL,
	0, 0, 0, NULL, NULL };

displayList signon_list[] = {
	' ', 10, 2, "This FAA pilot's written test program is brought", NULL,
	' ', 10, 3, "to you courtesy of Corwin Nichols - PP-ASEL", NULL,
	' ', 10, 4, "and others who have volunteered their efforts", NULL,
	' ', 10, 5, "without compensation.", NULL,
	' ', 10, 8, "If you have not already done so, please read the", NULL,
	' ', 10, 9, "accompanying 'readme.faa' file which came with this program.", NULL,
	' ', 10, 10, "No money is solicited, but your help in improving", NULL,
	' ', 10, 11, "this program will be appreciated by many.", NULL,
	' ', 10, 13, "-Corwin", NULL,
	0, 0, 0, NULL, NULL };

displayList settings_list[] = {
	' ', 8, 1, "Private Pilot Written Test Preparation Program  - 2.0a", NULL,
/*	' ', 10, 3,  "Select program settings", NULL, */
	'w', 10,  5, "select Working set  = %s", WorkingSetStr,
	'd', 10,  6, "Display answers     = %s", FeedbackStr,
	'n', 10,  7, "Number of questions = %d", &QuestionCount,
	'e', 10,  8, "sound Effects       = %s", SoundEffectStr,
	'a', 10, 10, "Answer the questions", NULL,
	't', 10, 11, "score the Test", NULL,
	'p', 10, 12, "Peek at score", NULL,
	's', 10, 13, "Select a new set of questions", NULL,
	'v', 10, 14, "saVe the current session", NULL,
	'l', 10, 15, "Load a saved session", NULL,
/*	'f', 10, 16, "dump questions to a File", NULL, */
	'h', 10, 17, "show Help screen", NULL,
	'q', 10, 18, "Quit this program", NULL,
	0, 0, 0, NULL, NULL };

setList	PP_SEL_list[] = {
	3000, 3999,
	0, 0 };

setList	PP_INST_list[] = {
	3000, 8999,
	0, 0 };

struct	{
	setList		*ActiveList;
	char		*ActiveListStr;	
	} WorkingSetList[] = {
	PP_SEL_list, "PP-ASEL",
	PP_INST_list, "PP-INST",
	NULL, NULL };

char	*HelpScreen[] = {
			"Help screen #1 - active KEYS\\n\\n\
A or 1      selects answer A.\\n\
B or 2      selects answer B.\\n\
C or 3      selects answer C.\\n\
G           'goes' to the first unanswered question.\\n\
M           'goes' to the next 'missed' question (note,\\n\
            the test must have been scored, or immediate\\n\
            feedback mode must be on.\\n\
H           displays these help screens.\\n\
ESC         exits back to the options menu, and \\n\
            is perfectly safe to do during a test.\\n\
CR, '+', TAB, DOWN ARROW   select the next question.\\n\
'-', SHIFT TAB, UP ARROW   select the prior question.\\n",

			"Help screen #2 - answering questions\\n\\n\
Pressing the 'A' key takes you into the question set.  You may select an answer \
and later go back to the same question and change your mind.  Once you have answered \
all of the questions in a set, you should return to the options menu and select the \
'score the test' option.  Then you can press the 'A' key and review your answers \
(but not change them).  Also, you may elect to turn on the 'immediate feedback' mode. \
When you do this, you get instant results on a question by question basis.  In this mode, \
you cannot change your answer once you see the results.  Many of the questions refer to \
external figures and tables.  You will need to have these tables and figures available \
to you in hardcopy form.  Hint, take a razor blade and cut them out of your study guide.",

			"Help Screen #3 - in general\\n\\n\
Other selections from the option menu allow you to 'peek' at your current score, \
although it doesn't say which questions you have missed, only how many.  You may also \
save a session for later completion.  The program starts with a default set of 60 \
questions (real life mode), but you can set the number as high as 200 for more intense \
practise.  Each time you change the number of questions, the program automatically \
generates a new set.  You can select a new set at any time.  When a new set is selected, \
any previous score is lost.  Questions are always selected randomly.  The 'working set' \
is currently stuck at PP-ASEL.  Perhaps more selections will be available in the future.",

			"Help screen #4 - lend a hand\\n\\n\
This program was written by me, Corwin Nichols.  My friend Ty Welburn scanned in the original questions \
(thank you) and I performed a first pass clean up.  Victoria Nichols (the wifely unit) helped get \
the right answers into the database.  This release of the program (early March 94) is the second. \
It has an updated question set, and the database has been extensively checked. \
There may be errors in the Q&A text, but I'm pretty sure the answers are alright.  Please let me know of any \
errors in the program or database.  I may be reached via the internet at 'corwin@microtech.com' \
or via fax at 415-424-1176. This program and database may be freely distributed as long as it is \
not for profit.  It is my intention to keep it up to date with the latest question base, \
and to provide it at no cost. But, I need your help. \
The database needs more help text, so please read the attached 'readme' file \
for instructions on the care and feeding of the database. Any suggestions on the program are \
welcomed as well.\\n-Corwin",

			NULL		/* Must be last in this list */
	};

char	PassedMsg[] = "Congratulations.  You made it!";
char	FailedMsg[] = "Back to school with you.  And remember, Nome wasn't built in a day.  Better luck next time.";

/*	prototypes */

void xy(int, int);
void gong(char *);
void not(void);
void yes(void);
int anykey(void);
void printQuestions(void);
void displayQuestion(questionList *, int);
void localize(questionList *);
int show_wrapped(char *, int, int, int);
void pop_question(questionList *);
void load_session(void);
void save_session(void);
void initialize(void);
int settings(void);
void reset_questions(void);
void err_abort(char *);
int paint_list(displayList *, int);
void ask_question(void);
void help(void);
void signoff(void);
void show_misses(void);
void score_test(void);
int parse_line(questionList *, char *, char HUGE *);
void show_keys(void);
void show_QandC(void);
void indicate_answer(int);
void check_answer(void);
void put_blank(int);
void wclrscr(void);
void wputch(int);
void wputs(char *);
void scorebox(void);
int	 w_getch(void);
void w_gets(char *);

main()
{
	time_t t;

	srand((unsigned)time(&t));
	initialize();
	if (settings() == 0)
		do {
			ask_question();
			} while(settings() == 0);
	signoff();
	return(0);
}

int settings(void)
{
	int newNum;
	char newNumStr[40];
	static	oldWorkingSet = -1;
	static	oldNumQuest = -1;

	while(TRUE)
	{
		switch(paint_list(settings_list, 1))
		{
			case 's':
				reset_questions();
				break;
/*			case 'w':	not yet implemented
				if (WorkingSetList[++WorkingSet].ActiveList == NULL)
					WorkingSet = 0;
				strcpy(WorkingSetStr, WorkingSetList[WorkingSet].ActiveListStr);
				break;
*/
			case 'd':
				if (ImmediateFeedback)
					ImmediateFeedback = FALSE, strcpy(FeedbackStr, "OFF");
				else
					ImmediateFeedback = TRUE, strcpy(FeedbackStr, "ON ");
				break;
			case 'e':
				if (SoundEffects)
					SoundEffects = FALSE, strcpy(SoundEffectStr, "OFF");
				else
					SoundEffects = TRUE, strcpy(SoundEffectStr, "ON ");
				break;
			case 'n':
				while(TRUE)
				{
					mvwprintw(Display, 22, 10, "Enter number of questions in test: ");
					w_gets(newNumStr);
					if (strlen(newNumStr) == 0)
						break;
					newNum = atoi(newNumStr);
					if (newNum < 2 || newNum > MAX_QUESTIONS_IN_ASKING_SET
								   || newNum > TotalQuestionCount)
					{
						wdeleteln(Display);
						continue;
					}
					QuestionCount = newNum;
					break;
				}
				break;
			case 'a':
				if (oldWorkingSet != WorkingSet || oldNumQuest != QuestionCount)
					reset_questions();
				oldNumQuest = QuestionCount;
				oldWorkingSet = WorkingSet;
				return(0);
			case 'q':
				return(1);
			case 'h':
				help();
				break;
			case 'v':
				save_session();
				break;
			case 'l':
				load_session();
				oldNumQuest = QuestionCount;
				oldWorkingSet = WorkingSet;
				break;
/*		obsoleted function
			case 'f':
				printQuestions();
				break;
*/
			case 'p':
				show_misses();
				break;
			case 't':
				score_test();
				break;
		}
	}
}

void help(void)
{
	int i;

	for (i = 0 ; ; i++)
	{
		if (HelpScreen[i] == NULL)
			break;
		wclrscr();
		show_wrapped(HelpScreen[i], 10, 2, 70);
		if (anykey() == ESC)
			break;
	}
}

void initialize(void)
{
	FILE	*fp;
	int		lineNum = 0, text_size;
	char	HUGE *textArea;
	struct	stat fileStatus;
	questionList	*questPtr;
	char	lineBuffer[MAX_LINE_SIZE];

	if(initscr() == NULL) {
		fprintf(stderr, "cannot initialize screen!\n");
		exit(1);
	}
	nonl();					/* more basic stuff */
	raw();
	noecho();
	pc_uptype(T_DIRECT);

	if ((Display = newwin(0, 0, 0, 0)) == NULL)
	{
		endwin();
		exit(1);
 	}
	if ((ScoreBox = subwin(Display, SCORE_BOX_BOTTOM, SCREEN_SIZE - SCORE_BOX_LEFT, 0, SCORE_BOX_LEFT)) == NULL)
	{
		endwin();
		exit(1);
 	}
	/* set up function key translation */
	keypad(Display, TRUE);
	leaveok(Display, FALSE);
	nodelay(Display, FALSE);
	wclrscr();

	paint_list(signon_list, 0);
	if ((Questions = malloc(sizeof(questionList) * MAX_QUESTIONS)) == NULL)
		err_abort("Could not allocate memory for the question structures");
	questPtr = Questions;
	if (stat(QUESTION_FILE, &fileStatus))
		err_abort("Couldn't find the question database file");
	if ((textArea = farmalloc(fileStatus.st_size)) == NULL)
		err_abort("Not enough memory to hold the question database");
	if ((fp = fopen(QUESTION_FILE, "r")) == NULL)
		err_abort("Couldn't open the question database file\n");
	mvwprintw(Display, 18, 10, "Loading the database...");
	wrefresh(Display);
	while (fgets(lineBuffer, MAX_LINE_SIZE, fp) != NULL)
	{
		if ((int)strlen(lineBuffer) < 3)	/* fixes Unix EOF test */
			break;
		lineNum++;
		if (lineBuffer[0] == '#')			/* comment line? */
			continue;
		*(lineBuffer + strlen(lineBuffer) - 1) = 0;	/* trim NL */
		if ((text_size = parse_line(questPtr, lineBuffer, textArea)) == 0)
		{
			wprintw(Display, "\nError parsing question database on line %d", lineNum);
			err_abort("Please fix and rerun");
		}
		mvwprintw(Display, 18, 35, "%d", questPtr->questionNum);
		wrefresh(Display);
		textArea += text_size;
		questPtr++, TotalQuestionCount++;
	}
	fclose(fp);
	mvwprintw(Display, 19, 10, "Loaded %d questions.", TotalQuestionCount);
	wrefresh(Display);
	anykey();
}

get_field(char *cp)
{
	if (*cp == 0)
		return(0);
	for ( ; *cp ; cp++)
		if (*cp == '|')
		{
			*cp = 0;
			break;
		}
	return(1);
}

void far_move(void FAR *src, void FAR *dest, unsigned length)
{
#ifdef	__MSDOS__
	movedata(FP_SEG(src), FP_OFF(src), FP_SEG(dest), FP_OFF(dest), length);
#else	/* unix */
	memmove(dest, src, length);
#endif
}


int parse_line(questionList *qp, char *buf, char HUGE *text)
{
	char *cp;
	char HUGE* qText;
	static int lastQnum = 0;
	int fldCount, answer, qNum, textSize = 0;

	for (fldCount = 0 ; fldCount < FIELD_COUNT ; fldCount++)
	{
		if (get_field(buf) == 0 && fldCount != FIELD_COUNT - 1)
		{
			wprintw(Display, "\nNot enough fields in line");
			return(0);
		}
		cp = buf;
		buf += strlen(buf) + 1;
		switch (fldCount)
		{
			case 0:
				qNum = atoi(cp);
				if (qNum < 3000 || qNum > 16000)
				{
					wprintw(Display, "\nBad question number");
					return(0);
				}
				if (qNum <= lastQnum)
				{
					wprintw(Display, "\nQuestion number sequence error");
					return(0);
				}
				lastQnum = qp->questionNum = qNum;
				break;
			case 1:
				answer = toupper(*cp);
				if (answer == 'X')		/* 'x' means any answer is correct */
				{
					qp->answer = 0;		/* special match any */
					break;
				}
				if (answer < 'A' || answer > 'C')
				{
					wprintw(Display, "\nBad answer field");
					return(0);
				}
				qp->answer = answer & 3;
				break;
			case 2:
				qText = text;
				qp->question = (char FAR *)text;
				goto move_text;
			case 3:
				qp->toAnswerA = text - qText;
				goto move_text;
			case 4:
				qp->toAnswerB = text - qText;
				goto move_text;
			case 5:
				qp->toAnswerC = text - qText;
				goto move_text;
			case 6:
				qp->toQuestionHelp = text - qText;
				goto move_text;
			case 7:
				qp->toFirstWrongHelp = text - qText;
				goto move_text;
			case 8:
				qp->toSecondWrongHelp = text - qText;
move_text:
				far_move(cp, text, strlen(cp) + 1);
				text += strlen(cp) + 1;
				textSize += strlen(cp) + 1;
				qp->toEnd = text - qText;
				break;
		}
	}
	return(textSize);
}

void build_working_set(setList *selectSet)
{
	int i, j;
	questionList *questPtr;

	WorkingListCount = 0;
	for( i = 0, j = TotalQuestionCount, questPtr = Questions ;
								j ; j--, i++, questPtr++)
	{
		while (questPtr->questionNum > selectSet->highValue)
		{
			selectSet++;
			if (selectSet->lowValue == selectSet->highValue)
				return;
		}
		if (questPtr->questionNum < selectSet->lowValue)
			continue;
		WorkingList[WorkingListCount++] = questPtr;
	}
}

void show_misses(void)
{
	if (Done == 0)
		return;
	mvwprintw(Display, 21, 10, "# misses = %d, # answered = %d, %% correct = %d", Missed,
			Done, (100 * (Done - Missed)) / Done);
	anykey();
}

void score_test(void)
{
	int	i;
	questControl *qc;

	CurrentQuestion = 0;
	Done = QuestionCount;
	Missed += ToGo;
	ToGo = 0;
	PassedPct = (Done - Missed) * 100 / Done;
	for (i = 0, qc = QuestionSet; i < QuestionCount ; i++, qc++)
	{
		if (qc->enteredAnswer == 0)
			qc->status |= IN_ERROR;
		qc->status |= LOCKED;
	}
	ImmediateFeedback = TRUE;
	strcpy(FeedbackStr, "ON ");
	paint_list(final_score_list, 0);
	if (PassedPct < 70)
		show_wrapped(FailedMsg, 10, 18, 50);
	else
		show_wrapped(PassedMsg, 10, 18, 50);
	anykey();
}

int qu_comp(const void *p1, const void *p2)
{
	return(((questControl *)p1)->question->questionNum - ((questControl *)p2)->question->questionNum);
}

void reset_questions(void)
{
	int	i, k;
	questControl *qc;

	build_working_set(WorkingSetList[WorkingSet].ActiveList);
	for (i = 0, qc = QuestionSet; i < QuestionCount ; i++, qc++)
	{
		qc->enteredAnswer = qc->status = 0;
		k = rand() % WorkingListCount;
		qc->question = WorkingList[k];
		memmove(&WorkingList[k], &WorkingList[k + 1],
				(--WorkingListCount - k) * sizeof(questionList *));
	}
	qsort(QuestionSet, QuestionCount, sizeof(questControl), qu_comp);
	Missed = Done = CurrentQuestion = 0;
	ToGo = QuestionCount;
}

void ask_question(void)
{
	int i, inkey, newAnswer = FALSE;

	leaveok(Display, TRUE);
	while(TRUE)
	{
		wclrscr();
		if (ImmediateFeedback)
			paint_list(score_list, 0);
		else
			paint_list(&score_list[1], 0);
		scorebox();
		show_QandC();
		show_keys();
		while (TRUE)
		{
			inkey = w_getch();
			if (inkey == 0)
				inkey = 128 + w_getch();
			switch (tolower(inkey))
			{
				case 'a':		/* select ans A */
				case '1':
					goto picked;
				case 'b':		/* select ans B */
				case '2':
					goto picked;
				case 'c':		/* select ans C */
				case '3':
					goto picked;
				case '!':		/* select correct answer */
					inkey = CorrectAns;
					goto picked;
picked:
					if (QuestionSet[CurrentQuestion].status & LOCKED)
					{
						gong("Changes no longer allowed");
						break;
					}
					QuestionSet[CurrentQuestion].enteredAnswer = inkey & 3;
					newAnswer = TRUE;
					indicate_answer(inkey);
					inkey = 0;
					break;
				case 'g':		/* go to first unanswered */
					if (ToGo == 0)
						break;
					for (CurrentQuestion = 0 ; CurrentQuestion < QuestionCount ;
								CurrentQuestion++)
						if (QuestionSet[CurrentQuestion].status == 0)
							break;
					break;
				case 'm':		/* go to next missed */
					if (Missed == 0 || ImmediateFeedback == FALSE)
						break;
					for (CurrentQuestion++, i = 0 ; i < QuestionCount ;
								CurrentQuestion++, i++)
					{
						if (CurrentQuestion == QuestionCount)
							CurrentQuestion = 0;
						if (QuestionSet[CurrentQuestion].status & IN_ERROR)
							break;
					}
					break;
				case 'h':		/* help! */
					help();
					break;
				case ESC:		/* back to options window */
				case 'q':		/* back to options window */
					leaveok(Display, FALSE);
					return;
				case CR:		/* next question */
				case '+':
				case TAB:
				case DOWN_ARROW:
					if (newAnswer)
						newAnswer = FALSE, check_answer();
					if (++CurrentQuestion == QuestionCount)
						CurrentQuestion = 0;
					break;
				case '-':
				case UP_ARROW:
				case BACK_TAB:
					if (newAnswer)
						newAnswer = FALSE, check_answer();
					if (--CurrentQuestion < 0)
						CurrentQuestion = QuestionCount - 1;
					break;
				default:
					inkey = 0;
			}
			if (inkey)
				break;
		}
	}
}

void check_answer(void)
{
	if (!(QuestionSet[CurrentQuestion].status & ANSWERED))
		Done++, ToGo--;
	QuestionSet[CurrentQuestion].status |= ANSWERED;
	if (ImmediateFeedback)
		QuestionSet[CurrentQuestion].status |= LOCKED;

	if (QuestionSet[CurrentQuestion].enteredAnswer == CorrectAns
		|| CorrectAns == 0)		/* special any answer is correct */
	{
		if (QuestionSet[CurrentQuestion].status & IN_ERROR)
			Missed--;
		QuestionSet[CurrentQuestion].status &= ~IN_ERROR;
		if (ImmediateFeedback)
			yes();
	}
	else
	{
		if ((QuestionSet[CurrentQuestion].status & IN_ERROR) == 0)
			Missed++;
		QuestionSet[CurrentQuestion].status |= IN_ERROR;
		if (ImmediateFeedback)
		{
			not();
			show_QandC();
			anykey();
		}
	}
}

void show_keys(void)
{
}

void show_QandC(void)
{
	questionList *qp;
	int currentLine;
	int	rMargin = 55;
	char status, answer;

	status = QuestionSet[CurrentQuestion].status;
	answer = QuestionSet[CurrentQuestion].enteredAnswer;

	qp = QuestionSet[CurrentQuestion].question;
	localize(qp);
	mvwprintw(Display, 2, 1, "%d.", qp->questionNum);
	currentLine = show_wrapped(Question, 7, 2, rMargin);

	if (answer == 1)
	{
		mvwprintw(Display, ++currentLine, 1, ">> A. ");
	}
	else
	{
		mvwprintw(Display, ++currentLine, 4, "A. ");
	}
	AnsY[1] = currentLine;
	currentLine = show_wrapped(AnswerA, 7, currentLine, rMargin);
	if (answer == 2)
	{
		mvwprintw(Display, ++currentLine, 1, ">> B. ");
	}
	else
	{
		mvwprintw(Display, ++currentLine, 4, "B. ");
	}
	AnsY[2] = currentLine;
	currentLine = show_wrapped(AnswerB, 7, currentLine, rMargin);
	if (answer == 3)
	{
		mvwprintw(Display, ++currentLine, 1, ">> C. ");
	}
	else
	{
		mvwprintw(Display, ++currentLine, 4, "C. ");
	}
	AnsY[3] = currentLine;
	currentLine = show_wrapped(AnswerC, 7, currentLine, rMargin);

	if (status & LOCKED)
	{
		xy(4, currentLine);
		wprintw(Display, "-----------------------------------------------------");
		xy(4, ++currentLine);
		if (answer == CorrectAns)
		{
			wprintw(Display, "You are correct.");
			return;
		}
		else
		{
			if (CorrectAns == 0)
				wprintw(Display, "The correct answer is: ANY/NONE");
			else
				wprintw(Display, "The correct answer is: %c", CorrectAns + '@');
		}
		currentLine += 1;
		if (strlen(QuestionHelp))
			currentLine = show_wrapped(QuestionHelp, 4, currentLine, rMargin);
		if (answer == 0)
			currentLine = show_wrapped("Remember, it's ALWAYS better to guess at an answer \
than to leave a question unanswered.",
					4, ++currentLine, rMargin);
		else if (answer == 1 || (answer == 2 && CorrectAns == 1))
		{
			if (strlen(Wrong1Help))
				currentLine = show_wrapped(Wrong1Help, 4, ++currentLine, rMargin);
		}
		else
		{
			if (strlen(Wrong2Help))
				currentLine = show_wrapped(Wrong2Help, 4, ++currentLine, rMargin);
		}
	}
}

void indicate_answer(int key)
{
	int i;

	for (i = 1 ; i < 4 ; i++)
	{
		mvwprintw(Display, AnsY[i], 1, "  ");
	}
	mvwprintw(Display, AnsY[key & 3], 1, ">>");
}

int paint_list(displayList *dispList, int doSelect)
{
	displayList *listPtr;
	int	inKey, tmpKey, matchKey;
	int lastX, lastY;
	char *pctPtr;

	wclrscr();
	for( listPtr = dispList ; listPtr->key ; listPtr++)
	{
		xy(listPtr->x, listPtr->y);
		lastY = listPtr->y;
		lastX = listPtr->x;
		if (listPtr->key > ' ')
		{
			wattron(Display, A_BOLD);
			wprintw(Display, "%c", toupper(listPtr->key));
			wattroff(Display, A_BOLD);
			wprintw(Display, " - ");
		}
		if ((pctPtr = strchr(listPtr->msg, '%')) != NULL)
		{
			if (*(pctPtr + 1) == 'd')
				wprintw(Display, listPtr->msg, *((int *)listPtr->value));
			else
				wprintw(Display, listPtr->msg, listPtr->value);
		}
		else
			wprintw(Display, listPtr->msg);
	}

	if (doSelect == 0)
		return(0);

	mvwprintw(Display, lastY + 2, lastX, "Select: ");

	while(TRUE)
	{
		inKey = w_getch();
		if (inKey == ESC)
			signoff();
		matchKey = tolower(inKey);
		for (listPtr = dispList ; listPtr->key ; listPtr++)
		{
			tmpKey = tolower(listPtr->key);
			if (tmpKey == matchKey)
				return(matchKey);
		}
	}
}

void signoff(void)
{
	paint_list(bye_list, 0);
	wrefresh(Display);
	endwin();
	exit(0);
}

void save_session(void)
{
	int	inkey, fo, szWrt = sizeof(int);
	char fileName[150];

retry:
	wclrscr();
	mvwprintw(Display, 10, 10, "Enter the name of the file to hold this session");
	mvwprintw(Display, 12, 10, "File name: ");
	w_gets(fileName);
	if (strlen(fileName) == 0)
		return;
	if (strchr(fileName, '?') || strchr(fileName, '*'))
	{
		gong("Wildcards are not allowed in the file name.");
		anykey();
		goto retry;
	}
	if (access(fileName, 0) == 0)
	{
		gong("A file of that name already exists.  Do you wish to overwrite it?");
		while(TRUE)
		{
			inkey = w_getch();
			inkey = tolower(inkey);
			if (inkey == 'n')
				goto retry;
			if (inkey == 'y')
				break;
		}
		unlink(fileName);
	}
	if ((fo = open(fileName, O_CREAT | O_WRONLY | O_BINARY, S_IREAD | S_IWRITE)) < 1)
	{
		gong("Error opening output file");
		anykey();
		goto retry;
	}
	if (write(fo, &QuestionCount, szWrt) != szWrt)
		goto wrtErr;
	if (write(fo, &CurrentQuestion, szWrt) != szWrt)
		goto wrtErr;
	szWrt = sizeof(questControl) * QuestionCount;
	if (write(fo, QuestionSet, szWrt) != szWrt)
		goto wrtErr;
	close(fo);
	return;
wrtErr:
	gong("Error writing session save file - ");
	anykey();
}

void load_session(void)
{
	int	i, inInt, fi, szRd = sizeof(int);
	questControl *qc;
	char fileName[150];
	struct	stat fileStatus;


	wclrscr();
	mvwprintw(Display, 10, 10, "Enter the name of the file containing the desired session");
	mvwprintw(Display, 12, 10, "File name: ");
	w_gets(fileName);
	if (strlen(fileName) == 0)
		return;
	if (stat(fileName, &fileStatus))
	{
		gong("Couldn't find the input file.");
		anykey();
		return;
	}
	if ((fi = open(fileName, O_RDONLY | O_BINARY)) < 1)
	{
		gong("Error opening input file.");
		anykey();
		return;
	}
	if (read(fi, &inInt, szRd) != szRd)
		goto rdErr;

	if (fileStatus.st_size != (inInt * sizeof(questControl) + 2 * szRd))
	{
		gong("Error, specified input file is probably not a saved session");
		anykey();
		return;
	}
	QuestionCount = inInt;
	if (read(fi, &CurrentQuestion, szRd) != szRd)
		goto rdErr;
	szRd = sizeof(questControl) * QuestionCount;
	if (read(fi, QuestionSet, szRd) != szRd)
		goto rdErr;
	close(fi);

	Missed = Done = 0;
	for (i = 0, qc = QuestionSet; i < QuestionCount ; i++, qc++)
	{
		if (qc->status & IN_ERROR)
			Missed++;
		if (qc->status & ANSWERED)
			Done++;
	}
	ToGo = QuestionCount - Done;
	return;
rdErr:
	gong("Error reading session save file");
	anykey();
}

#if 0		/* this function was never completed or used */
void pop_question(questionList *thisQuestion)
{
	int leftMargin = 5, currentLine = 5;
	int rightMargin = 65;
	int key, inkey;

	wclrscr();
	currentLine = show_wrapped((char *)thisQuestion->question, leftMargin, currentLine, rightMargin);
	mvwprintw(Display, ++currentLine, leftMargin, "A -");
	currentLine = show_wrapped((char *)thisQuestion->question, leftMargin + 4, currentLine, rightMargin);
	mvwprintw(Display, ++currentLine, leftMargin, "B -");
	currentLine = show_wrapped((char *)thisQuestion->question, leftMargin + 4, currentLine, rightMargin);
	mvwprintw(Display, ++currentLine, leftMargin, "C -");
	currentLine = show_wrapped((char *)thisQuestion->question, leftMargin + 4, currentLine, rightMargin);
	mvwprintw(Display, ++currentLine, leftMargin, "Enter answer -> ");
	while(TRUE)
	{
		inkey = w_getch();
		key = tolower(inkey);
		if (key == 'a' || key == 'b' || key == 'c')
		{
			wputch(inkey);
			break;
		}
	}
	xy(leftMargin, ++currentLine);
	if (key == thisQuestion->answer)
	{
		if (ImmediateFeedback)
		{
			wprintw(Display, "Correct!");
			anykey();
		}
		return;
	}
	if (ImmediateFeedback)
	{
		wprintw(Display, "Sorry, wrong answer.");
		anykey();
	}
}
#endif

int show_wrapped(char *text, int x, int y, int rMargin)
{
	int	xNow, yNow;
	char *cp2, *stopper, *stop2;
	char tmpLine[120];

	while (TRUE)
	{
		if (y)
			xy(x, y++);
		else
		{
			getyx(Display, yNow, xNow);
			if (xNow < x)
				put_blank(x - xNow);
			xNow = yNow;		/* silly way of removing compiler warning */
		}
		for( cp2 = text ; (cp2 - text < rMargin - x) && *cp2 ; cp2++)
		{
			if (*cp2 == ' ')
				stop2 = stopper = cp2;
			if (*cp2 == '\\' && *(cp2 + 1) == 'n')
			{
				stop2 = stopper = cp2++;
				stop2++;
/*				*stopper++ = 0; */
				break;
			}
		}
		if (*cp2 == 0)
		{
			wputs(text);
			break;
		}
		else
		{
			memcpy(tmpLine, text, stopper - text);
			tmpLine[stopper - text] = 0;
			wputs(tmpLine);
			text = stop2 + 1;
		}
	}
	return(y);
}

void put_blank(int n)
{
	while(n--)
		wputch(' ');
}

int anykey()
{
	int i;

	xy(2, LINES - 2);
	for (i = 70 ; i ; --i)
		waddch(Display, ' ');
	mvwprintw(Display, LINES - 2, 20, "Press any key to continue...");
	return(w_getch());
}

void err_abort(char *msg)
{
	mvwprintw(Display, 22, 10, msg);
	wrefresh(Display);
	endwin();
	exit(1);
}

#if 0		/* this function not ported to curses */
void printQuestions(void)
{
	questionList	*questPtr;
	int i, key, startNum, mode = CONTINUOUS;
	char startStr[30];

	wclrscr();
	mvwprintw(Display, 10, 10, "Enter the starting question number: ");
	w_gets(startStr);
	if (strlen(startStr) != 0)
		startNum = atoi(startStr);
	mvwprintw(Display, 12, 10, "Indicate correct answers? ");
	while(TRUE)
	{
		key = w_getch();
		key = tolower(key);
		if (key == 'n')
		{
			wputch(key);
			break;
		}
		if (key == 'y')
		{
			wputch(key);
			mode |= SHOW_ANSWERS;
			break;
		}
	}
	wprintw(Display, "\n\n");
	wrefresh(Display);
	for( i = TotalQuestionCount, questPtr = Questions ;
								i ; i--, questPtr++)
	{
		if (questPtr->questionNum < startNum)
			continue;
		displayQuestion(questPtr, mode);
		wrefresh(Display);
	}
	wprintw(Display, "\n\n  Done.\n\n");
	anykey();
}

void displayQuestion(questionList *qp, int mode)
{
	int x = 6, y = 4;

	localize(qp);
	if (mode & CONTINUOUS)
	{
		wprintw(Display, "%d. ", qp->questionNum);
		show_wrapped(Question, x, 0, 40);
		if (qp->answer == 0 && (mode & SHOW_ANSWERS))
			wprintw(Display, "\n>> A- ");
		else
			wprintw(Display, "\n   A- ");
		show_wrapped(AnswerA, x, 0, 40);
		if (qp->answer == 1 && (mode & SHOW_ANSWERS))
			wprintw(Display, "\n>> B- ");
		else
			wprintw(Display, "\n   B- ");
		show_wrapped(AnswerB, x, 0, 40);
		if (qp->answer == 2 && (mode & SHOW_ANSWERS))
			wprintw(Display, "\n>> C- ");
		else
			wprintw(Display, "\n   C- ");
		show_wrapped(AnswerC, x, 0, 40);
		wprintw(Display, "\n\n");
	}
	else
	{
		wclrscr();
		mvwprintw(Display, y, 0, "%d. ", qp->questionNum);
		y = show_wrapped(Question, x, y, 40);
		mvwprintw(Display, ++y, 3, "A- ");
		y = show_wrapped(AnswerA, x, y, 40);
		mvwprintw(Display, ++y, 3, "B- ");
		y = show_wrapped(AnswerB, x, y, 40);
		mvwprintw(Display, ++y, 3, "C- ");
		y = show_wrapped(AnswerC, x, y, 40);
	}
}
#endif

void localize(questionList *qp)
{
	char FAR *cp;
	char FAR *qq;

	CorrectAns = qp->answer;
	qq = cp = qp->question;
	far_move(cp, Question, qp->toAnswerA);
	cp = qq + qp->toAnswerA;
	far_move(cp, AnswerA, qp->toAnswerB - qp->toAnswerA);
	cp = qq + qp->toAnswerB;
	far_move(cp, AnswerB, qp->toAnswerC - qp->toAnswerB);
	cp = qq + qp->toAnswerC;
	far_move(cp, AnswerC, qp->toQuestionHelp - qp->toAnswerC);
	cp = qq + qp->toQuestionHelp;
	far_move(cp, QuestionHelp, qp->toFirstWrongHelp - qp->toQuestionHelp);
	cp = qq + qp->toFirstWrongHelp;
	far_move(cp, Wrong1Help, qp->toSecondWrongHelp - qp->toFirstWrongHelp);
	cp = qq + qp->toSecondWrongHelp;
	far_move(cp, Wrong2Help, qp->toEnd - qp->toSecondWrongHelp);
}

void gong(char *str)
{
	int i, j = 400;

	mvwprintw(Display, LINES - 3, 10, str);
	wrefresh(Display);

#ifdef __MSDOS__
	if (SoundEffects)
	{
		/* Make a weird sound: */
		for (i = 30 ; i != 0 ; --i)
		{
			sound (j);
			j -= 10;
			delay(20);
			nosound ();
			delay(10);
		}
	}
	else
		delay(1000);
#else	/* unix */
	sleep(1);
#endif
}


void not(void)
{
	int i;
	int high = 500, low = 300;

	mvwprintw(Display, 23, 10, "No, I don't think so.");
	wrefresh(Display);

#ifdef	__MSDOS__	/* Make a weird sound: */
	if (SoundEffects)
	{
		for (i = 3 ; i ; --i)
		{
			sound (high);
			high -= 25;
			delay(400);
			sound (low);
			low -= 25;
			delay(400);
		}
		nosound ();
	}
	else
		delay(2400);
#else	/* unix */
	sleep(2);
#endif
}

void yes(void)
{
	int i, k = 0;
	static freqs[] = {200, 250, 350, 530};

	mvwprintw(Display, 23, 10, "Correct!");
	wrefresh(Display);

#ifdef	__MSDOS__
	/* Make a weird sound: */
	if (SoundEffects)
	{
		for (i = 4 ; i ; --i)
		{
			sound (freqs[k++]);
			delay(400);
		}
		delay(400);
		nosound();
	}
	else
		delay(1600);
#else	/* unix */
	sleep(2);
#endif
}

void xy(int x, int y)
{
	wmove(Display, y, x);
}

void wclrscr(void)
{
	wclear(Display);
	box(Display, V_LINE, H_LINE);
}

void wputch(int c)
{
	waddch(Display, c);
}

void wputs(char *str)
{
	waddstr(Display, str);
}

void scorebox(void)
{
	box(ScoreBox, V_LINE, H_LINE);
	mvwaddch(Display, 0, SCORE_BOX_LEFT, TTEE);
	mvwaddch(Display, SCORE_BOX_BOTTOM - 1, SCREEN_SIZE - 1, RTEE);
}

int w_getch()
{
	wrefresh(Display);
	return(wgetch(Display));
}

void w_gets(char *buffer)
{
	wrefresh(Display);
	echo();
	wgetstr(Display, buffer);
	noecho();
}

